# Updates a engagement model with the specified ID.

This method will update an existing engagement model with the specified ID.

Endpoint: PUT /engagementModels/{tenantId}/{id}
Version: v1-2025-04-18
Security: knox-authorizer

## Security:

  - `knox-authorizer` (unknown)
    http bearer JWT

## Path parameters:

  - `tenantId` (string, required)
    The id of the tenant being accessed.

  - `id` (string, required)
    The ID of the engagement model to update.

## Request body:

  - `application/json` (unknown)
    The updated engagement model that will be saved.

## Request fields (application/json):

  - `components` (array)

  - `components.custom_metric_id` (string)
    The custom to use for engagement

  - `components.metric_rules` (array, required)

  - `components.metric_rules.ending_range` (number)
    The ending range for the rule

  - `components.metric_rules.points` (number, required)
    Points to assign, 100 total max

  - `components.metric_rules.starting_range` (number, required)
    The starting range for the rule

  - `components.metric_type` (string, required)
    Enum: "custom", "system"

  - `components.name` (string, required)
    Name of the component

  - `components.system_metric` (string)
    The metric to use for engagement

  - `components.weight` (number, required)
    The weight out of 100

  - `enable_engagement_categories` (boolean)
    If true, contacts are assigned categories based on engagement scores

  - `engagement_category_rules` (array, required)

  - `engagement_category_rules.category_id` (string, required)
    The engagement category

  - `engagement_category_rules.maximum_percentile_rank` (number)
    Maximum percentile rank to match this rule

  - `engagement_category_rules.maximum_score` (number, required)
    Maximum score to match this rule

  - `engagement_category_rules.minimum_percentile_rank` (number)
    Minimum percentile rank to match this rule

  - `engagement_category_rules.minimum_score` (number, required)
    Minimum score to match this rule

  - `id` (string, required)
    The unique, string identifier of this engagement model

  - `is_active` (boolean)
    Whether or not the model is active

  - `name` (string, required)
    The name of the engagement model

  - `sys_bulk_load_at` (string)
    If this record was loaded via bulk, the timestamp when the record was processed

  - `sys_bulk_load_id` (string)
    If this record was loaded via bulk, the ID of the bulk load process

  - `sys_bulk_load_pk` (string)
    If this record was loaded via bulk, the tenant and key of the bulk load process used as a partition key

  - `sys_bulk_load_record_no` (number)
    If this record was loaded via bulk, the record number in the source file

  - `sys_bulk_load_source_file` (string)
    If this record was loaded via bulk, the source file

  - `sys_calculated_field_error` (string)
    The error associated with the calculated field

  - `sys_calculated_field_errors` (array)

  - `sys_calculated_field_errors.error` (string)

  - `sys_calculated_field_errors.field` (string)

  - `sys_configuration_snapshot_id` (string)
    If a snapshot was restored/applies to this record, the ID of the snapshot

  - `sys_created_at` (string, required)
    The date/time that this record was created, expressed in ISO-8601 date format

  - `sys_created_by_id` (string, required)
    The ID of the user that created this record

  - `sys_deleted_by_id` (string)
    The ID of the user that deleted (or last tried to delete) this object

  - `sys_directive` (string)
    Means for passing directive information into an object processing logic

  - `sys_external_id` (string)
    The ID that a record has from an external system or data import

  - `sys_has_files_in_s3` (boolean)
    If true, this record has files in S3. If false, it doesnt, so no need to hit S3 upon deletion

  - `sys_last_bulk_data_operation_id` (string)
    If this record was last touched by a bulk data operation, the ID of that operation

  - `sys_last_bulk_data_operation_sys_version` (string)
    If this record was last touched by a bulk data operation, the sys_version at the time of that operation

  - `sys_last_modified_at` (string, required)
    The date/time that this record record was last modified, expressed in ISO-8601 date format

  - `sys_last_modified_by_id` (string, required)
    The ID of the user that last modified this record

  - `sys_last_security_context` (object)
    The security context of the last insert, modify, or delete performed on this item

  - `sys_locked` (boolean)
    If set, this record is locked and cannot be changed via the API

  - `sys_snapshot_base_version` (number)
    The version to use as a base when creating a configuration snapshot; if not set, 1 is used. Helpful when creating a sandbox

  - `sys_version` (number)
    A number representing the version of this record in the database

  - `type` (string)
    The target of this engagement model
    Enum: "contact", "organization"

## Response 200:

  - `200` (unknown)
    The engagement model was updated successfully.

## Response 200 fields (application/json):

  - `components` (array)

  - `components.custom_metric_id` (string)
    The custom to use for engagement

  - `components.metric_rules` (array, required)

  - `components.metric_rules.ending_range` (number)
    The ending range for the rule

  - `components.metric_rules.points` (number, required)
    Points to assign, 100 total max

  - `components.metric_rules.starting_range` (number, required)
    The starting range for the rule

  - `components.metric_type` (string, required)
    Enum: "custom", "system"

  - `components.name` (string, required)
    Name of the component

  - `components.system_metric` (string)
    The metric to use for engagement

  - `components.weight` (number, required)
    The weight out of 100

  - `enable_engagement_categories` (boolean)
    If true, contacts are assigned categories based on engagement scores

  - `engagement_category_rules` (array, required)

  - `engagement_category_rules.category_id` (string, required)
    The engagement category

  - `engagement_category_rules.maximum_percentile_rank` (number)
    Maximum percentile rank to match this rule

  - `engagement_category_rules.maximum_score` (number, required)
    Maximum score to match this rule

  - `engagement_category_rules.minimum_percentile_rank` (number)
    Minimum percentile rank to match this rule

  - `engagement_category_rules.minimum_score` (number, required)
    Minimum score to match this rule

  - `id` (string, required)
    The unique, string identifier of this engagement model

  - `is_active` (boolean)
    Whether or not the model is active

  - `name` (string, required)
    The name of the engagement model

  - `sys_bulk_load_at` (string)
    If this record was loaded via bulk, the timestamp when the record was processed

  - `sys_bulk_load_id` (string)
    If this record was loaded via bulk, the ID of the bulk load process

  - `sys_bulk_load_pk` (string)
    If this record was loaded via bulk, the tenant and key of the bulk load process used as a partition key

  - `sys_bulk_load_record_no` (number)
    If this record was loaded via bulk, the record number in the source file

  - `sys_bulk_load_source_file` (string)
    If this record was loaded via bulk, the source file

  - `sys_calculated_field_error` (string)
    The error associated with the calculated field

  - `sys_calculated_field_errors` (array)

  - `sys_calculated_field_errors.error` (string)

  - `sys_calculated_field_errors.field` (string)

  - `sys_configuration_snapshot_id` (string)
    If a snapshot was restored/applies to this record, the ID of the snapshot

  - `sys_created_at` (string, required)
    The date/time that this record was created, expressed in ISO-8601 date format

  - `sys_created_by_id` (string, required)
    The ID of the user that created this record

  - `sys_deleted_by_id` (string)
    The ID of the user that deleted (or last tried to delete) this object

  - `sys_directive` (string)
    Means for passing directive information into an object processing logic

  - `sys_external_id` (string)
    The ID that a record has from an external system or data import

  - `sys_has_files_in_s3` (boolean)
    If true, this record has files in S3. If false, it doesnt, so no need to hit S3 upon deletion

  - `sys_last_bulk_data_operation_id` (string)
    If this record was last touched by a bulk data operation, the ID of that operation

  - `sys_last_bulk_data_operation_sys_version` (string)
    If this record was last touched by a bulk data operation, the sys_version at the time of that operation

  - `sys_last_modified_at` (string, required)
    The date/time that this record record was last modified, expressed in ISO-8601 date format

  - `sys_last_modified_by_id` (string, required)
    The ID of the user that last modified this record

  - `sys_last_security_context` (object)
    The security context of the last insert, modify, or delete performed on this item

  - `sys_locked` (boolean)
    If set, this record is locked and cannot be changed via the API

  - `sys_snapshot_base_version` (number)
    The version to use as a base when creating a configuration snapshot; if not set, 1 is used. Helpful when creating a sandbox

  - `sys_version` (number)
    A number representing the version of this record in the database

  - `type` (string)
    The target of this engagement model
    Enum: "contact", "organization"

## Response 200 headers (application/json):

  - `Access-Control-Allow-Headers` (string)

  - `Access-Control-Allow-Methods` (string)

  - `Access-Control-Allow-Origin` (string)

## Response 400:

  - `400` (unknown)
    The engagement model supplied was not valid.

## Response 400 headers:

  - `Access-Control-Allow-Headers` (string)

  - `Access-Control-Allow-Methods` (string)

  - `Access-Control-Allow-Origin` (string)

## Response 401:

  - `401` (unknown)
    Unauthorized.

## Response 401 headers:

  - `Access-Control-Allow-Headers` (string)

  - `Access-Control-Allow-Methods` (string)

  - `Access-Control-Allow-Origin` (string)

## Response 403:

  - `403` (unknown)
    Forbidden.

## Response 403 headers:

  - `Access-Control-Allow-Headers` (string)

  - `Access-Control-Allow-Methods` (string)

  - `Access-Control-Allow-Origin` (string)

## Response 404:

  - `404` (unknown)
    The engagement model could not be found.

## Response 404 headers:

  - `Access-Control-Allow-Headers` (string)

  - `Access-Control-Allow-Methods` (string)

  - `Access-Control-Allow-Origin` (string)

## Response 405:

  - `405` (unknown)
    The request method is not allowed.

## Response 405 headers:

  - `Access-Control-Allow-Headers` (string)

  - `Access-Control-Allow-Methods` (string)

  - `Access-Control-Allow-Origin` (string)

## Response 409:

  - `409` (unknown)
    The engagement model could not be saved because it refers to/depends on a non-existent object.

## Response 409 headers:

  - `Access-Control-Allow-Headers` (string)

  - `Access-Control-Allow-Methods` (string)

  - `Access-Control-Allow-Origin` (string)

## Response 429:

  - `429` (unknown)
    Limit exceeded... unable to retrieve engagement model based on tenant limits.

## Response 429 headers:

  - `Access-Control-Allow-Headers` (string)

  - `Access-Control-Allow-Methods` (string)

  - `Access-Control-Allow-Origin` (string)

## Response 500:

  - `500` (unknown)
    General server error.

## Response 500 headers:

  - `Access-Control-Allow-Headers` (string)

  - `Access-Control-Allow-Methods` (string)

  - `Access-Control-Allow-Origin` (string)

